#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include "tasks.h"
#include "resources.h"
#include "result.h"

int ff()
{
	memset(&rst, 0, sizeof(struct result));
	time_t start_time = time(NULL);
	int i, j, k, l;
	struct dev *cur_dev;
	struct server *cur_srv;
	struct cloud *cur_cloud;
	float cur_dev_energy;
	for(i=0; i<num_task; i++)
	{
		cur_dev = tasks[i].dev;
		//scheduling the task to the device
		for(j=0; j<cur_dev->core; j++)
		{
			cur_dev->use_time[j] += tasks[i].length / cur_dev->cap;
			cur_dev_energy = cal_energy_dev(cur_dev, 0.0, 0);
			if((cur_dev->use_time[j] <= tasks[i].deadline) && 
				(cur_dev_energy <= cur_dev->pow_budget))
			{
				rst.local_num ++;
				rst.local_size += tasks[i].length;
				rst.fin_num ++;
				rst.fin_size += tasks[i].length;
				rst.local_input += tasks[i].sizeIn;
				rst.input += tasks[i].sizeIn;
				goto next_task;
			}

			else
			{
				cur_dev->use_time[j] -= tasks[i].length / cur_dev->cap;
			}
		}

		
		//scheduling the task to an edge server
		for(j=0; j<num_edge; j++)
		{
			if(cur_dev->edge != j)
				continue;
			for(k=0; k<edges[j].svr_num; k++)
			{
				cur_srv = edges[j].svr + k;
				for(l=0; l<cur_srv->core; l++)
				{
					cur_dev->updata += tasks[i].sizeIn;
					cur_dev_energy = cal_energy_dev(cur_dev, tasks[i].sizeIn, edges[j].bw_down);
					
					cur_srv->in_time[l] += tasks[i].sizeIn / edges[j].bw_down * 8;
					//the later of the ready time for input data and cpu
					if(cur_srv->in_time[l] > cur_srv->cpu_time[l])
						cur_srv->cpu_time[l] += cur_srv->in_time[l] - cur_srv->cpu_time[l];
					cur_srv->cpu_time[l] += tasks[i].length / cur_srv->cap;
					
					if((cur_srv->cpu_time[l] <= tasks[i].deadline) && 
						(cur_dev_energy <= cur_dev->pow_budget))
					{
						rst.edge_num ++;
						rst.edge_size += tasks[i].length;
						rst.fin_num ++;
						rst.fin_size += tasks[i].length;
						rst.edge_input += tasks[i].sizeIn;
						rst.input += tasks[i].sizeIn;
						cur_dev->updata_edge[j] += tasks[i].sizeIn;
						goto next_task;
					}

					else
					{
						cur_dev->updata -= tasks[i].sizeIn;
						
						cur_srv->cpu_time[l] -= tasks[i].length / cur_srv->cap;
						if(cur_srv->in_time[l] > cur_srv->cpu_time[l])
							cur_srv->cpu_time[l] -= cur_srv->in_time[l] - cur_srv->cpu_time[l];
						cur_srv->in_time[l] -= tasks[i].sizeIn / edges[j].bw_down * 8;
					}
				}
			}

		}


		//scheduling the task to a cloud
		for(j=0; j<num_cloud; j++)
		{
			cur_cloud = clouds + j;
			struct vm *cur_vm = cur_cloud->vms;
			while(cur_vm)
			{
				cur_dev->updata += tasks[i].sizeIn;
				cur_dev_energy = cal_energy_dev(cur_dev, tasks[i].sizeIn, cur_cloud->bw_down);
				
				cur_vm->in_time += tasks[i].sizeIn / cur_cloud->bw_down * 8;
				if(cur_vm->in_time > cur_vm->cpu_time)
					cur_vm->cpu_time += cur_vm->in_time - cur_vm->cpu_time;
				cur_vm->cpu_time += tasks[i].length / cur_cloud->cap;
				
				if((cur_vm->cpu_time <= tasks[i].deadline) && 
					(cur_dev_energy <= cur_dev->pow_budget))
				{
					rst.cloud_num ++;
					rst.cloud_size += tasks[i].length;
					rst.fin_num ++;
					rst.fin_size += tasks[i].length;
					rst.cloud_input += tasks[i].sizeIn;
					rst.input += tasks[i].sizeIn;
					cur_dev->updata_cloud[j] += tasks[i].sizeIn;
					goto next_task;
				}

				else
				{
					cur_dev->updata -= tasks[i].sizeIn;
					
					cur_vm->cpu_time -= tasks[i].length / cur_cloud->cap;
					if(cur_vm->in_time > cur_vm->cpu_time)
						cur_vm->cpu_time -= cur_vm->in_time - cur_vm->cpu_time;
					cur_vm->in_time -= tasks[i].sizeIn / cur_cloud->bw_down * 8;
				}
				cur_vm = cur_vm->next;
			}

			// rent a new VM
			cur_dev->updata += tasks[i].sizeIn;
			cur_dev_energy = cal_energy_dev(cur_dev, tasks[i].sizeIn, cur_cloud->bw_down);
			
			float ft = tasks[i].sizeIn / cur_cloud->bw_down * 8 + tasks[i].length / cur_cloud->cap;
			if((ft <= tasks[i].deadline) && (cur_dev_energy <= cur_dev->pow_budget))
			{
				rst.cloud_num ++;
				rst.cloud_size += tasks[i].length;
				rst.fin_num ++;
				rst.fin_size += tasks[i].length;
				rst.cloud_input += tasks[i].sizeIn;
				rst.input += tasks[i].sizeIn;
				cur_dev->updata_cloud[j] += tasks[i].sizeIn;
				cur_vm = (struct vm *)malloc(sizeof(struct vm));
				if(! cur_vm)
				{
					printf("ERROR malloc for a new vm\n");
					exit(0);

				}
				memset(cur_vm, 0, sizeof(struct vm));
				cur_vm->in_time = tasks[i].sizeIn / cur_cloud->bw_down * 8;
				cur_vm->cpu_time = cur_vm->in_time + tasks[i].length / cur_cloud->cap;
				cur_vm->cloud = cur_cloud;
				//insert vm in the vm list
				struct vm *tmp;
				if(! cur_cloud->vms)
					 cur_cloud->vms = cur_vm;
				else
				{
					tmp = cur_cloud->vms;
					while(tmp->next)
						tmp = tmp->next;
					tmp->next = cur_vm;
					cur_vm->next = NULL;
				}
				goto next_task;
			}

			else
			{
				cur_dev->updata -= tasks[i].sizeIn;
			}
		}

		next_task:
		;
	}
	rst.second = (int) (time(NULL) - start_time);
	float max_time = 0.0;
	for(i=0; i<num_dev; i++)
	{
		rst.dev_energy += cal_energy_dev(devs + i, 0.0, 0);
		if(rst.dev_energy < 0)
		{
			printf("XXX===%f\n", devs[i].updata);
			printf("TTT===%f\t%f\t%f\t%f\n", devs[i].use_time[0], devs[i].use_time[1], devs[i].use_time[2], devs[i].use_time[3]);
		}
		max_time = find_max_time(devs[i].use_time, devs[i].core);
		rst.local_used += max_time * devs[i].cap * devs[i].core;
		if(rst.ft < max_time)
			rst.ft = max_time;
	}
	for(i=0; i<num_edge; i++)
	{
		for(j=0; j<edges[i].svr_num; j++)
		{
			cur_srv = edges[i].svr + j;
			max_time = find_max_time(cur_srv->cpu_time, cur_srv->core);
			rst.edge_used += max_time * cur_srv->cap * cur_srv->core;
			if(rst.ft < max_time)
				rst.ft = max_time;
		}
	}
	for(i=0; i<num_cloud; i++)
	{
		rst.cost += cal_cost(clouds + i);
	}
	rst.total_used = rst.local_used + rst.edge_used + rst.cloud_used;
	return rst.fin_num;
}

int ffd()
{
	sort_task_length_dec();
	return ff();
}

int edf()
{
	sort_task_deadline_inc();
	return ff();
}


void end();
