#ifndef _RESULT_H_
#define _RESULT_H_

struct result{
	int fin_num; //finished task number
	float fin_size;
	float input;
	float uti;
	float ft;
	float act;		//ms/GHz, ft / finish_size * 1000

	/* For public clouds*/
	float cost;	//cost of renting cloud resources
	float cost_eff; //efficiency in task size per dollar
	int cloud_num;
	float cloud_size;
	float cloud_input;
	float cloud_used;
	float cloud_uti;
	
	/* For edges*/
	float edge_size;
	float edge_input;
	int edge_num;
	float edge_used;
	float edge_uti;
	float edge_energy;

	/* For local cloud, or devices*/
	float local_size;
	float local_input;
	int local_num;
	float local_used;
	float local_uti;
	float dev_energy;
	
	float total_used;	//used resources in amount for calculating utilization = fin_size/total_used;

	int second;
};

extern struct result rst;

void print_title();
void print_result();


#endif
