#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "tasks.h"


int num_task = 1000;
float total_length = 0;
float total_input = 0;

struct tsk tasks[MAX_TASKS];

void init_tasks()
{
	memset(tasks, 0, MAX_TASKS * sizeof(struct tsk));
	int i;
	srand( time(NULL) );
	for(i=0; i<num_task; i++)
	{
		tasks[i].length = 1999.0 * rand() / RAND_MAX + 1;;//1 ~ 2000GHz
		//CJ-JNCA2020-12-Data-intensive application scheduling on Mobile Edge Cloud Computing
		tasks[i].sizeIn = rand() % 481 + 20; //20 ~ 500MB
		tasks[i].deadline = rand() % 501 + 1000; //500 ~ 1500s
		
//		tasks[i].sizeOut = tasks[i].sizeIn * 0.1;
		tasks[i].para = rand() % 32 + 1; //1 ~ 32
		tasks[i].dev = devs + rand() % num_dev;

		total_length += tasks[i].length;
		total_input += tasks[i].sizeIn;
	}
}

int compare_dl_inc(const void *p1, const void *p2)
{
	struct tsk *tsk1, *tsk2;
	tsk1 = (struct tsk *)p1;
	tsk2 = (struct tsk *)p2;
	return (int)(tsk1->deadline - tsk2->deadline);
}
void sort_task_deadline_inc()
{
	qsort(tasks, num_task, sizeof(struct tsk), compare_dl_inc);
}

int compare_length_dec(const void *p1, const void *p2)
{
	struct tsk *tsk1, *tsk2;
	tsk1 = (struct tsk *)p1;
	tsk2 = (struct tsk *)p2;
	return (int)(tsk2->length - tsk1->length);
}
void sort_task_length_dec()
{
	qsort(tasks, num_task, sizeof(struct tsk), compare_length_dec);
}

void sort_task_length_dec_part(struct tsk tasks[], int num_task)
{
	qsort(tasks, num_task, sizeof(struct tsk), compare_length_dec);
}


int compare_input_dec(const void *p1, const void *p2)
{
	struct tsk *tsk1, *tsk2;
	tsk1 = (struct tsk *)p1;
	tsk2 = (struct tsk *)p2;
	return (int)(tsk2->sizeIn - tsk1->sizeIn);
}
void sort_task_input_dec()
{
	qsort(tasks, num_task, sizeof(struct tsk), compare_input_dec);
}

